/* 
  $Id: KFCWnd.h 3 2009-12-20 19:12:53Z krkim $ $Revision: 3 $
  $HeadURL: https://krkim-laptop/svn/KFC/trunk/KFCWnd.h $
 */

/* W E L C O M E    T O    'K  F  C  W  N  D' 
 *                                 S I M P L E    W I N D O W   L I B R A R Y 
 * KFC - K)RKIM's F)oundation C)lasses Library for MS-Windows SDK Platform.
 *       IT IS FOR SDK CLASSES NOT MFC!!
 * Author: K.R Kim (Kyeong Rae Kim) / Korea.
 * E-mail: Quasar@hitel.net / http://www.kebi.com/~netzip (defuncted)
 * This library is for simple and light build and running without many MFC DLLs.
 * version: 1.0    2000/01/07
 * purpose: like-as MFC interface and C++ class for WINSDK Platform so easy to
 *          implement a overide or wrapping inherited classes.
 * http://durumul.com , http://durumul.blogspot.com , http://krkim.net
 *
 * Copyright(c) 2001,2006,2009 KRKIM (DURUMUL.COM) Allrights reserved.
 * mailto:krkim@durumul.com,mailto:durumul@gmail.com
 *
 * This material is provided "as is", with absolutely no warranty expressed
 * or implied. Any use is at your own risk.
 *
 * Permission to use or copy this software for any purpose is hereby granted
 * without fee, provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 * official release : http://www.durumul.com/kfclib
 *
 */

//You can converting MFC custom class to WIN32/SDK control Class via this KFCWNDLIB.
//KFCSBar.h/cpp demonstrate how to customize control window.

//Version : 
// 2006.07.20 KRKIM Add By KRKIM For interactive SDK window with class via Attach,Subclass
// 2009-10-12 KRKIM Add OnSetFocus(),OnLButtonDblClk(),many other messages handler.
// 2009-10-20 KRKIM Renewal some part of Window Procedure like WTL.
// 2010-03-03 KRKIM Add MoveCtrl,ResizeCtrl,ResizeWindow to use easily.
// 2012-04-24 KRKIM Add GetScreenRectToMonitor for Multi Monitor
#pragma once

#include "KFC.h"
#include "KFCException.h"
#include "KFCMsg.h"
#include "KFCApp.h"
#include "KFCDC.h"

_KFC_BEGIN_PACK(WND)

#define MONITOR_AREA     0x0000        // use monitor entire area
#define MONITOR_WORKAREA 0x0001        // use monitor work area
#define MONITOR_CENTER   0x0010        // center rect to monitor
#define MONITOR_CLIP     0x0020        // clip rect to monitor

class KFCWnd;
class kxFrame;

// special struct for WM_SIZEPARENT
struct KX_SIZEPARENTPARAMS
{
	HDWP hDWP;       // handle for DeferWindowPos
	RECT rect;       // parent client rectangle (trim as appropriate)
	SIZE sizeTotal;  // total size on each side as layout proceeds
	BOOL bStretch;   // should stretch to fill all space
	BOOL bResize;//Ʈ ũ⸦ ¡ Ұΰ
};

class KFCMessageFilter
{
public:
	virtual kfc_msg BOOL ProcMsg(UINT message, WPARAM wParam, LPARAM lParam,LRESULT& lResult) = 0;
};

class KFCWnd : public KFCMessageFilter
{
public:
	KFCWnd(HWND hWnd = NULL);
	virtual ~KFCWnd();
	// MESSAGE HANDLER *************************************************************************** >>
	KFC_BEGIN_MAP()
		KFC_HANDLE_MSG(WM_CREATE,OnCreate)
		KFC_HANDLE_MSG(WM_ACTIVATE,OnActivate)
		KFC_HANDLE_MSG(WM_DRAWITEM,OnDrawItem)
		KFC_HANDLE_MSG(WM_MEASUREITEM,OnMeasureItem)
		KFC_HANDLE_MSG(WM_INITMENUPOPUP,OnInitMenuPopup)
		KFC_HANDLE_MSG(WM_IDLEUPDATECMDUI,OnIdleUpdateCmdUI)
#if 0
		KFC_HANDLE_MSG(WM_CLOSE,OnClose)
		KFC_HANDLE_MSG(WM_DESTROY,OnDestroy)
		KFC_HANDLE_MSG(WM_SIZE,OnSize)
		KFC_HANDLE_MSG(WM_GETMINMAXINFO,OnGetMinMaxInfo)
		KFC_HANDLE_MSG(WM_WINDOWPOSCHANGING,OnWindowPosChanging)
		KFC_HANDLE_MSG(WM_WINDOWPOSCHANGED,OnWindowPosChanged)
		KFC_HANDLE_MSG(WM_GETDLGCODE,OnGetDlgCode)
		KFC_HANDLE_MSG(WM_COMMAND,OnCommand)
		KFC_HANDLE_MSG(WM_SYSCOMMAND,OnSysCommand)
		KFC_HANDLE_MSG(WM_NOTIFY,OnNotify)
		KFC_HANDLE_MSG(WM_PAINT,OnPaint)
		KFC_HANDLE_MSG(WM_ERASEBKGND,OnEraseBkgnd)
		KFC_HANDLE_MSG(WM_SETFOCUS,OnSetFocus)
		KFC_HANDLE_MSG(WM_KILLFOCUS,OnKillFocus)
		KFC_HANDLE_MSG(WM_SETCURSOR,OnSetCursor)
		KFC_HANDLE_MSG(WM_INITMENU,OnInitMenu)
		KFC_HANDLE_MSG(WM_MENUSELECT,OnMenuSelect)
		KFC_HANDLE_MSG(WM_LBUTTONDOWN,OnLButtonDown)
		KFC_HANDLE_MSG(WM_LBUTTONUP,OnLButtonUp)
		KFC_HANDLE_MSG(WM_LBUTTONDBLCLK,OnLButtonDblClk)
		KFC_HANDLE_MSG(WM_RBUTTONDOWN,OnRButtonDown)
		KFC_HANDLE_MSG(WM_RBUTTONUP,OnRButtonUp)
		KFC_HANDLE_MSG(WM_RBUTTONDBLCLK,OnRButtonDblClk)
		KFC_HANDLE_MSG(WM_MOUSEMOVE,OnMouseMove)
		KFC_HANDLE_MSG(WM_MOUSEWHEEL,OnMouseWheel)
		KFC_HANDLE_MSG(WM_MOUSEHWHEEL,OnMouseHWheel)
		KFC_HANDLE_MSG(WM_MOUSELEAVE,OnMouseLeave)
		KFC_HANDLE_MSG(WM_CONTEXTMENU,OnContextMenu)
		KFC_HANDLE_MSG(WM_CAPTURECHANGED,OnCaptureChanged)
		KFC_HANDLE_MSG(WM_NCHITTEST,OnNcHitTest)
		KFC_HANDLE_MSG(WM_NCLBUTTONDOWN,OnNcLButtonDown)
		KFC_HANDLE_MSG(WM_NCLBUTTONDOWN,OnNcLButtonDblClk)
		KFC_HANDLE_MSG(WM_CTLCOLORBTN,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLOREDIT,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLORDLG,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLORLISTBOX,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLORSCROLLBAR,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLORSTATIC,OnCtlColor)
		KFC_HANDLE_MSG(WM_CTLCOLORMSGBOX,OnCtlColor)
		KFC_HANDLE_MSG(WM_KEYDOWN,OnKeyDown)
		KFC_HANDLE_MSG(WM_KEYUP,OnKeyUp)
		KFC_HANDLE_MSG(WM_CHAR,OnChar)
		KFC_HANDLE_MSG(WM_TIMER,OnTimer)
		KFC_HANDLE_MSG(WM_QUERYENDSESSION,OnQueryEndSession)
		KFC_HANDLE_MSG(WM_HSCROLL,OnHScroll)
		KFC_HANDLE_MSG(WM_VSCROLL,OnVScroll)
		KFC_HANDLE_MSG(WM_SETTINGCHANGE,OnSettingChange)
		KFC_HANDLE_MSG(WM_CANCELMODE,OnCancelMode)
		KFC_HANDLE_MSG(WM_ENABLE,OnEnableWindow)
		KFC_HANDLE_MSG(WM_DROPFILES,OnDropFiles)
		KFC_HANDLE_MSG(WM_FONTCHANGE,OnFontChange)
		KFC_HANDLE_MSG(WM_SYSCOLORCHANGE,OnSysColorChange)
		KFC_HANDLE_MSG(WM_SETTEXT,OnSetText)
		KFC_HANDLE_MSG(WM_GETTEXT,OnGetText)
		KFC_HANDLE_MSG(WM_SETFONT,OnSetFont)
		KFC_HANDLE_MSG(WM_GETFONT,OnGetFont)
		KFC_HANDLE_MSG(WM_IME_STARTCOMPOSITION,OnIMEStartComposition)
		KFC_HANDLE_MSG(WM_IME_ENDCOMPOSITION,OnIMEEndComposition)
		KFC_HANDLE_MSG(WM_IME_SETCONTEXT,OnIMESetContext)
		KFC_HANDLE_MSG(WM_IME_COMPOSITION,OnIMEComposition)
		KFC_HANDLE_MSG(WM_IME_NOTIFY,OnIMENotify)
		KFC_HANDLE_MSG(WM_IME_CHAR,OnIMEChar)
		KFC_HANDLE_MSG(WM_IME_KEYDOWN,OnIMEKeyDown)
		KFC_HANDLE_MSG(WM_ENTERMENULOOP,OnEnterMenuLoop)
		KFC_HANDLE_MSG(WM_EXITMENULOOP,OnExitMenuLoop)
#endif
	KFC_END_MAP()
protected:
	// MESSAGE HANDLER *************************************************************************** <<
	/*message event handler function do not virtual */
	kfc_msg BOOL OnCreate(LPCREATESTRUCT lpCreateStruct);
	kfc_msg BOOL OnClose();//if TRUE (handled),no close.
	kfc_msg void OnDestroy();
	kfc_msg void OnNcDestroy();
	kfc_msg BOOL OnSize(UINT state, int cx, int cy);
	kfc_msg BOOL OnMove(int x, int y);
	kfc_msg BOOL OnNCCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS * lpcsp,LRESULT &lResult);
	kfc_msg BOOL OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	kfc_msg BOOL OnWindowPosChanging(LPWINDOWPOS lpwndpos);
	kfc_msg BOOL OnWindowPosChanged(LPWINDOWPOS lpwndpos);
	kfc_msg UINT OnGetDlgCode(LPMSG lpMsg);
	kfc_msg BOOL OnCommand(UINT nID, HWND hWndCtrl, UINT nNotifyCode);//if 0 ,to default
	kfc_msg BOOL OnSysCommand(UINT nID,int x,int y);//if 0 ,to default
	kfc_msg BOOL OnNotify(int idCtrl,LPNMHDR lpnmh,LRESULT &lResult);
	kfc_msg void OnPaint();
	kfc_msg BOOL OnNcPaint(HRGN hRgn);
	kfc_msg BOOL OnEraseBkgnd(HDC hDC);//If pass to system erase it default,return FALSE.otherwise if you erase manually,return TRUE. 
	kfc_msg BOOL OnDrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	kfc_msg BOOL OnMeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	kfc_msg BOOL OnCompareItem(LPCOMPAREITEMSTRUCT lpCompareItem,LRESULT &lResult);// lResult =  -1,0,1
	kfc_msg BOOL OnDeleteItem(LPDELETEITEMSTRUCT lpDeleteItem);//TRUE if Handled
	kfc_msg BOOL OnVkeyToItem(UINT vk, HWND hwndListbox, int iCaret,LRESULT &lResult);
	kfc_msg BOOL OnCharToItem(UINT ch, HWND hwndListbox, int iCaret,LRESULT &lResult);
	kfc_msg void OnSetFocus(HWND hwndOldFocus);
	kfc_msg void OnKillFocus(HWND hwndNewFocus);
	kfc_msg BOOL OnSetCursor(HWND hWndCursor,UINT nHitTest,UINT message);//If an application processes this message, it should return TRUE to halt further processing or FALSE to continue.
	kfc_msg void OnInitMenu(HMENU hMenu);
	kfc_msg void OnInitMenuPopup(HMENU hPopupMenu,UINT nIndex,BOOL bSysMenu);
	kfc_msg void OnMenuSelect(UINT nItemID,UINT nFlags,HMENU hSysMenu);
	kfc_msg BOOL OnMenuChar(UINT nChar,UINT nFlags,HMENU hMenu,LRESULT & lResult);
	kfc_msg void OnEnterMenuLoop(BOOL bIsTrackPopupMenu);
	kfc_msg void OnExitMenuLoop(BOOL bIsTrackPopupMenu);
	kfc_msg BOOL OnLButtonDown(UINT nFlags,POINT point);
	kfc_msg BOOL OnLButtonUp(UINT nFlags,POINT point);
	kfc_msg BOOL OnLButtonDblClk(UINT nFlags,POINT point);
	kfc_msg BOOL OnRButtonDown(UINT nFlags,POINT point);
	kfc_msg BOOL OnRButtonUp(UINT nFlags,POINT point);
	kfc_msg BOOL OnRButtonDblClk(UINT nFlags,POINT point); 
	kfc_msg BOOL OnMouseMove(UINT nFlags,POINT point);
	kfc_msg BOOL OnMouseWheel(UINT nFlags, short zDelta,POINT point);
	kfc_msg BOOL OnMouseHWheel(UINT nFlags, short zDelta,POINT point);
	kfc_msg BOOL OnMouseLeave();
	kfc_msg BOOL OnContextMenu(HWND hFocus,POINT point);
	kfc_msg BOOL OnNcHitTest(POINT point,LRESULT &lResult);
	kfc_msg BOOL OnNcLButtonDown(UINT nHitTest,POINT point);
	kfc_msg BOOL OnNcLButtonDblClk(UINT nHitTest,POINT point);
	kfc_msg BOOL OnCaptureChanged(HWND hNewCapture);
	kfc_msg HBRUSH OnCtlColor(HDC hDC,HWND hChild,UINT nCtlColor);
	kfc_msg BOOL OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	kfc_msg BOOL OnKeyUp(UINT nChar,UINT nRepCnt,UINT nFlags);
	kfc_msg BOOL OnChar(UINT nChar,UINT nRepCnt,UINT nFlags);
	kfc_msg void OnTimer(UINT_PTR nIDEvent);
	kfc_msg BOOL OnQueryEndSession();//Applications should respect the user's intentions and return TRUE. 
	kfc_msg BOOL OnHScroll(UINT nSBCode,UINT nPos,HWND hWndBar);
	kfc_msg BOOL OnVScroll(UINT nSBCode,UINT nPos,HWND hWndBar);
	kfc_msg BOOL OnSettingChange(UINT nFlags,LPCTSTR lpszSection);
	kfc_msg void OnCancelMode();//it is called when a dialog box or message box is displayed.This gives we the opportunity to cancel modes such as mouse capture.
	kfc_msg void OnEnableWindow(BOOL bEnable);
	kfc_msg void OnDropFiles(HDROP hDropInfo);
	kfc_msg void OnFontChange();
	kfc_msg void OnActivateApp(BOOL bActive,DWORD dwThreadID);
	kfc_msg void OnActivate(UINT nState,HWND hWndOther,BOOL bMinimized);
	kfc_msg void OnSysColorChange();
	kfc_msg void OnSetText(LPTSTR szNewText);
	kfc_msg int  OnGetText(int cchTextMax, LPTSTR lpszText);
	kfc_msg BOOL OnSetFont(HFONT hFont, BOOL bRedraw);
	kfc_msg BOOL OnGetFont(HFONT & hFont);
	// IME >>
	kfc_msg LRESULT OnIMEStartComposition(WPARAM wParam, LPARAM lParam); /*toggle IME mode - begin*/
	kfc_msg LRESULT OnIMEEndComposition(WPARAM wParam, LPARAM lParam);   /*toggle IME mode - end*/
	kfc_msg LRESULT OnIMESetContext(WPARAM wParam, LPARAM lParam);       /*called when initilize IME or ACTIVATE own window.*/
	kfc_msg LRESULT OnIMEComposition(WPARAM wParam, LPARAM lParam);      /*called when doing composite or complete DBCS */
	kfc_msg LRESULT OnIMENotify(WPARAM wParam, LPARAM lParam);
	kfc_msg LRESULT OnIMEChar(WPARAM wParam, LPARAM lParam);             /*called when complete DBCS */
	kfc_msg LRESULT OnIMEKeyDown(WPARAM wParam, LPARAM lParam);          /*called when doing composite ,PRESS VIRTUAL KEY like as arrow.. */
	kfc_msg LRESULT OnIdleUpdateCmdUI(WPARAM wParam, LPARAM lParam);
public:
	kxString GetTitle();
	void SetTitle(LPTSTR szTitle);
	HWND GetSafeHwnd(){	return m_hWnd;}
	void SetHandle(HWND hWnd);
	HWND SetParent(HWND hParent);
	KFCWnd* SetParent(KFCWnd* pWnd);
	HWND GetHandle(void) {return m_hWnd;}
	BOOL Show(int nCmdShow){return ::ShowWindow(m_hWnd,nCmdShow);}
	void Update(){ UpdateWindow();}
	void SetTransparent(HWND hWnd,int rate,BOOL bKeepLayer = TRUE);
	operator HWND(){ return m_hWnd; }
	BOOL SubMenuSystem(HMENU hPopupMenu);
	BOOL GetClientRect(LPRECT lpRect){ ASSERT(::IsWindow(m_hWnd)); return ::GetClientRect(m_hWnd,lpRect);}
	BOOL GetWindowRect(LPRECT lpRect){ ASSERT(::IsWindow(m_hWnd));return ::GetWindowRect(m_hWnd, lpRect);}
	int GetWindowText(LPTSTR lpText,int nMaxBuffer){ return ::GetWindowText(m_hWnd,lpText,nMaxBuffer);}
	BOOL SetWindowText(LPCTSTR lpText){ return ::SetWindowText(m_hWnd,lpText);}
	UINT_PTR SetTimer(UINT_PTR nIDEvent,UINT uElapse,TIMERPROC lpTimerFunc=NULL){ return ::SetTimer(m_hWnd,nIDEvent,uElapse,lpTimerFunc);}
	BOOL KillTimer(UINT_PTR nIDEvent){ return ::KillTimer(m_hWnd,nIDEvent);}
	BOOL IsWindowEnabled(){ return ::IsWindowEnabled(m_hWnd);}
	void BringWindowToTop()	{ ASSERT(::IsWindow(m_hWnd)); ::BringWindowToTop(m_hWnd); }
	BOOL SetWindowPos(HWND m_hWndAfter, int x, int y, int cx, int cy, UINT uFlags);
	BOOL SetWindowPos(HWND m_hWndAfter,RECT rc, UINT uFlags);
	DWORD DeferWindow(HDWP hWinPosInfo,HWND hWnd,HWND hWndInsertAfter,int x, int y, int cx,int cy, UINT uFlags);
	DWORD DeferWindow(HDWP hWinPosInfo,HWND hWnd,HWND hWndInsertAfter,RECT rc, UINT uFlags);
	HDC GetDC()	{ ASSERT(::IsWindow(m_hWnd));  return ::GetDC(m_hWnd); }
	HDC GetDCEx(HRGN prgnClip, DWORD flags)	{ ASSERT(::IsWindow(m_hWnd));  return ::GetDCEx(m_hWnd, prgnClip, flags); }
	HDC GetWindowDC() { ASSERT(::IsWindow(m_hWnd));  return ::GetWindowDC(m_hWnd); }
	int ReleaseDC(HDC hDC) { ASSERT(::IsWindow(m_hWnd));  return ::ReleaseDC(m_hWnd, hDC); }
	virtual BOOL IsFrameWnd() const { return FALSE;}
	virtual kxFrame *GetParentFrame();
	virtual kxFrame *GetDockingFrame();
	//2000,02,08 added new
	//static KFCWnd * GetPointer(HWND hWnd){ return reinterpret_cast<KFCWnd*>(GetWindowLongPtr(hWnd,GWL_USERDATA));	}
	//static KFCWnd * GetPointer(HWND hWnd){ return (KFCWnd*)GetWindowLongPtr(hWnd,GWLP_USERDATA);	}
	//static void SetPointer(HWND hWnd, KFCWnd *pWnd){ SetWindowLongPtr(hWnd, GWLP_USERDATA, (LONG)pWnd); }
	static KFCWnd * GetPointer(HWND hWnd){ return (KFCWnd*)GetProp(hWnd, "KFCWND_PROP"); }
	static void SetPointer(HWND hWnd, KFCWnd *pWnd){ SetProp(hWnd, "KFCWND_PROP", (HANDLE)pWnd); }

	static KFCWnd * FromHandle(HWND hWnd);
	virtual BOOL Create(LPCTSTR lpszClassName,LPCTSTR lpszWindowName, DWORD dwStyle,const RECT& rect,KFCWnd* pParentWnd,UINT nID);
	virtual BOOL CreateEx(DWORD dwExStyle, LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,int x,int y,int nWidth,int nHeight,HWND hWndParent,HMENU nIDorHMenu,LPVOID lpParam);
	virtual BOOL CreateEx(DWORD dwExStyle, LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,const RECT& rect,HWND hWndParent,UINT nID,LPVOID lpParam = NULL);
	virtual BOOL CreateEx(DWORD dwExStyle, LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,const RECT& rect, KFCWnd* pParentWnd,UINT nID,LPVOID lpParam = NULL);
	
	virtual BOOL Close() { if(m_hWnd && ::IsWindow(m_hWnd)) return ::SendMessage(m_hWnd,WM_CLOSE,0L,0L); return 0;}
	virtual void DestroyWindow(){	if(m_hWnd && ::IsWindow(m_hWnd)) ::DestroyWindow(m_hWnd);}
	virtual BOOL RegisterWndClass(WNDCLASSEX &wcex);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	HWND SetFocus(){ return ::SetFocus(m_hWnd); }
	HWND GetFocus() { return ::GetFocus(); }
	HWND SetCapture(){	ASSERT(::IsWindow(m_hWnd));	return ::SetCapture(m_hWnd);}
	BOOL CreateCaret(HBITMAP hBitmap,int nWidth,int nHeight){return ::CreateCaret(m_hWnd,hBitmap,nWidth,nHeight);}
	BOOL ShowCaret() { return ::ShowCaret(m_hWnd);}
	BOOL HideCaret() { return ::HideCaret(m_hWnd);}
	UINT SetSafeTimer(UINT nTimerID,const UINT nElapsed);
	void ScreenToClient(LPRECT lpRect) const;
	void ScreenToClient(HWND hWnd,LPRECT lpRect) const;
	void ScreenToClient(LPPOINT lpPoint)  const{ ::ScreenToClient(m_hWnd,lpPoint); }
	void ClientToScreen(HWND hWnd,LPRECT lpRect) const;
	void ClientToScreen(LPRECT lpRect) const;
	void ClientToScreen(LPPOINT lpPoint)  const{ ::ClientToScreen(m_hWnd,lpPoint); }
	BOOL GetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo);
	int SetScrollInfo(int nBar, LPSCROLLINFO lpScrollInfo, BOOL bRedraw = TRUE);
	int ScrollWindowEx(int dx, int dy, LPCRECT lpRectScroll, LPCRECT lpRectClip, HRGN hRgnUpdate, LPRECT lpRectUpdate, UINT uFlags);
	int ScrollWindowEx(int dx, int dy, UINT uFlags, LPCRECT lpRectScroll = NULL, LPCRECT lpRectClip = NULL, HRGN hRgnUpdate = NULL, LPRECT lpRectUpdate = NULL);
	int SetScrollPos(int nBar, int nPos, BOOL bRedraw = TRUE);
	BOOL SetScrollRange(int nBar, int nMinPos, int nMaxPos, BOOL bRedraw = TRUE);
	BOOL ShowScrollBar(UINT nBar, BOOL bShow = TRUE);
	BOOL EnableScrollBar(UINT uSBFlags, UINT uArrowFlags = ESB_ENABLE_BOTH);

	void Invalidate(BOOL bErase = TRUE){ if(IsWindow()) ::InvalidateRect(m_hWnd,NULL,bErase);}
	void InvalidateRect(const RECT *rect,BOOL bErase = TRUE){ if(IsWindow()) ::InvalidateRect(m_hWnd,rect,bErase);}
	void ShowWindow(int nCmdShow) { if(IsWindow()) ::ShowWindow(m_hWnd,nCmdShow);}
	virtual BOOL IsWindow() { if(m_hWnd && ::IsWindow(m_hWnd)) return TRUE;return FALSE; }
	virtual BOOL IsWindowVisible();//WS_VISIBLE Ӽ ־ θâ̵ ڽ̵ HIDEǸ FALSE( true)
	virtual BOOL IsWindowHasVisible();//WS_VISIBLE Ӽ  TRUE ,IsWindowVisible  FALSE  WS_VISIBLE Ӽ ִ.
	void UpdateWindow(){ if(m_hWnd && ::IsWindow(m_hWnd)) ::UpdateWindow(m_hWnd); }
	void SetRedraw(BOOL bRedraw);
	BOOL RedrawWindow(LPCRECT lprcUpdate = NULL,HRGN hrgnUpdate = NULL,UINT flags = RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	//dialog routine
	HWND GetDlgItem(int nID) const;
	void SetDlgItemText(int nID,LPCTSTR lpszString);
	int GetDlgItemText(int nID,LPTSTR lpStr,int nMaxCount) const;
	UINT GetDlgItemInt(int nID,BOOL *lpTranslated = NULL,BOOL bSigned = TRUE);
	BOOL SetDlgItemInt(int nID,UINT uValue,BOOL bSigned = TRUE);
	void CheckDlgButton(int nIDButton,UINT nCheck);
	void CheckRadioButton(int nIDFirstButton,int nIDLastButton,int nIDCheckButton);
	UINT IsDlgButtonChecked(int nIDButton) const;
	int  GetCheckedRadioButton(int nIDFirstButton,int nIDLastButton);

	LRESULT SendDlgItemMessage(int nID,UINT message,WPARAM wParam = 0,LPARAM lParam = 0);
	LRESULT SendMessage(UINT message,WPARAM wParam = 0,LPARAM lParam = 0);
	LRESULT PostMessage(UINT message,WPARAM wParam = 0,LPARAM lParam = 0);
	HWND m_hWnd;
	UINT m_ID;
	HWND m_hParentWnd;
	KFCWnd *m_parent;
	int m_nIconIndex;
	void SetIconIndex(int nIndex){ m_nIconIndex = nIndex;}
	int  GetIconIndex(){ return m_nIconIndex;}
	KFCWnd *GetParentWnd();
	HWND GetParent(){ return ::GetParent(m_hWnd);}
	DWORD GetStyle(){ return ::GetWindowLongPtr(m_hWnd,GWL_STYLE);}
	DWORD GetExStyle(){ return ::GetWindowLongPtr(m_hWnd,GWL_EXSTYLE);}
	void CenterWindow(HWND hWndAlter = NULL);
	static void GetScreenRectToMonitor(LPRECT prc, UINT flags = MONITOR_AREA|MONITOR_CLIP);
	void GetWindowRectToMonitor(LPRECT prc, UINT flags = MONITOR_AREA|MONITOR_CLIP);
	void MoveWindowToMonitor(UINT flags = MONITOR_AREA|MONITOR_CLIP);
	void MoveWindow(RECT rc,BOOL bRepaint = TRUE);
	void MoveCtrl(UINT nID,int diffx,int diffy); /*2010.03.03*/
	void ResizeCtrl(UINT nID,int diffx,int diffy);
	void ResizeWindow(HWND hWnd,int diffx,int diffy);
	void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = 0);
	void RepositionWindow(KX_SIZEPARENTPARAMS* lpLayout,HWND hWnd, LPCRECT lpRect,UINT nFlags = SWP_NOACTIVATE|SWP_NOZORDER);/*2010.09.01*/
	void RepositionBars(UINT nIDFirst, UINT nIDLast, UINT nIDLeftOver,
		BOOL bQuery, LPRECT lpRectParam = NULL,LPCRECT lpRectClient = NULL, BOOL bStretch = TRUE,BOOL bResizeBars = TRUE);
	void SendMessageToDescendants(UINT message, WPARAM wParam = 0,
		LPARAM lParam = 0, BOOL bDeep = TRUE, BOOL bOnlyPerm = FALSE);
	static void SendMessageToDescendants(HWND hWnd, UINT message,
		WPARAM wParam, LPARAM lParam, BOOL bDeep, BOOL bOnlyPerm);
	virtual BOOL UpdateBarsPosition(HDWP hDWP,RECT& rect, BOOL bResizeBars = TRUE);
	void EnableShow(UINT nID,BOOL bEnable); /* enable  show  ÿ */
	BOOL ModifyStyle(DWORD dwRemove, DWORD dwAdd, UINT nFlags = 0);
	BOOL ModifyStyleEx(DWORD dwRemove, DWORD dwAdd, UINT nFlags = 0);
	void GetFrameSpacing(LPRECT lprcFrameGap);//get spacing between frame and client
	virtual HFONT GetFont();
	virtual void SetFont(HFONT hFont,BOOL bRedraw = TRUE);
	int GetDlgCtrlID();
	int SetDlgCtrlID(int nID);
	virtual void NextDlgCtrl(HWND hWnd = NULL){ FORWARD_WM_NEXTDLGCTL(hWnd ? hWnd : m_hWnd,FALSE,FALSE,::SendMessage);}//VK_TAB
	virtual void PrevDlgCtrl(HWND hWnd = NULL){ FORWARD_WM_NEXTDLGCTL(hWnd ? hWnd : m_hWnd,TRUE,FALSE,::SendMessage);}//SHIFT + VK_TAB
	virtual void SetTabOrder(HWND hWndAfter = HWND_TOP);
	void SetFadeInOnCreated(BOOL bFadeInCreated,int nStep = 10,int nStepDelay = 5);
	BOOL FadeWindow(int nStep = 10,int nStepDelay = 20,BOOL bKeepLayer = TRUE,BOOL bUseThread = TRUE,DWORD dwThreadTimeout = 0,BOOL bForceKillThread = FALSE);//nStep < 0 means FadeOut,nStepDelay is milisecond
	BOOL StopFadeThread(DWORD dwTimeout,BOOL bForce);
	BOOL IsFadeThreadRunning();
	/* This called from KFCApp directly */
	virtual BOOL PreTranslateMessage(MSG* pMsg);/*If parent is modal dialog,this event wiil not be reached never */

	/* internal event */
	virtual void OnFirstActive();
	virtual void OnFinalMessage();
	/*pure virtual function makes win an abstract class.*/
	virtual void ExcludeChildCtrl(HDC hDC);//To exclude child area,use style WS_CLIPCHILDREN not using ExcludeChildCtrl(hDC);
	BOOL Attach(HWND hWndNew,BOOL bForce = FALSE);
	HWND Detach();
	virtual void PreSubClassWindow();
	virtual BOOL SubClassWindow(HWND hWnd,BOOL bForce = FALSE);
	virtual HWND UnSubClassWindow();
	//BOOL SubclassDlgItem(UINT nID, CWnd* pParent);
	HICON GetIcon( BOOL bBigIcon=TRUE) const;
	HICON SetIcon( HICON hIcon, BOOL bBigIcon=TRUE);
	
	virtual UINT InvokeIMECommand(WPARAM wParam, LPARAM lParam);/* IME   */

	virtual WNDPROC GetWindowProc() { return WindowProc; }
	static LRESULT CALLBACK KFCWndBaseProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);	
	static LRESULT CALLBACK WindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
	virtual LRESULT DefWindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
	virtual LRESULT Default();//use it if need to set bHandled = TRUE and pass to default proc
	virtual BOOL OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam,LRESULT& lResult);
	
	//Reflect Notification
	virtual BOOL ReflectNotifications(UINT message, WPARAM wParam, LPARAM lParam,LRESULT& lResult);
	virtual BOOL DefaultReflectionHandler(UINT message, WPARAM wParam, LPARAM lParam, LRESULT& lResult);
	virtual BOOL OnReflectChildNotifications(UINT message, WPARAM wParam, LPARAM lParam);//determine if reflect child or not,TRUE = allow
	virtual HWND GetReflectChild(UINT message, WPARAM wParam, LPARAM lParam);
	virtual void OnUpdateCmdUI(kxFrame* pTarget, BOOL bDisableIfNoHndler);
protected:
	/* old method for reflection message
	void AddReflectMap();
	void DelReflectMap();
	HWND FindReflectMap(HWND hWnd);
	*/
	//FadeInOut
	static DWORD FadeThread(LPVOID pParam);
	DWORD FadeProc();
private:
	int m_nWndMsg;
	kxString m_wndTitle;
protected:
	MSG	m_LastMsg;
	KFCModule::KFCCreateWndData m_cd;
	WNDPROC m_fnSuper;
	BOOL  m_bCreatedByMe,m_nActive;
	BOOL  m_bSubClassed;
	DWORD m_dwState;
	int   m_nRefMap;//reflect map ref count
	enum { WINSTATE_DESTROYED = 0x00000001 };
	//FadeInOut
	typedef struct _FADEINOUT{
		HANDLE hThreadFadeIn;
		BOOL   bCreated;
		int    nStep;
		int    nDelay;
		BOOL   bAbort;
		BOOL   bKeepLayer;//WS_EX_LAYED Ÿ 
	}FADEINOUT;
	FADEINOUT m_FadeIO;
};

_KFC_END_PACK

/*
 * Copyright(c) 2000-2010 krkim allrights reserved.
 */
